/**
 *   @author   Everis
 *   @since    February 21, 2019 
 *   @desc     Apex Class Test of FII_Util_GSM
 *   @history  February 21, 2019 - everis (JVC) - Create Apex Class 
 */
@isTest
private class FII_Util_GSM_Test {

	private static final Id IDRT_CAS_ACTION = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_ACTION).Id;
	
	private static final String CONTACT_LASTNAME = 'Test2';
	private static final String ACCOUNT_NIF = '85258421C';
	private static final String LEAD_EMAIL = 'test@test.com';
	private static final String NEED_SUBJECT = 'NEED';
	private static final String NEED_LEAD_SUBJECT = 'NEED_LEAD';
	private static final String ACTION_CASE_SUBJECT = 'ACTION CASE';

	@testSetup static void setup(){
        Test.setMock(HttpCalloutMock.class, new UtilHttpMock.BasicMock());
		Test.startTest();
		Contact con = UtilTest.createContact();
		con.Language__c = 'Español';
		AccountTriggerHandler.bypassTrigger = true;
		insert con;
		AccountTriggerHandler.bypassTrigger = false;
		Lead newLead = UtilTest.createLead();
		insert newLead;
		
		// Account for a Quote
		Account acc = new Account();
        acc.Name = 'ACME';
        acc.Contact_method_cd__c = 'SMS';
        acc.LastName__c = 'ARTEFACTS';
        acc.Identifier_Type__c = 'N';
        acc.LicensedPhysical_or_legal__c = 'Corporate customer';
        acc.Physical_or_legal_cd__c = 'Corporate Customer';
        acc.NIF_CIF_Customer_NIE__c = 'ES48625582V';
        acc.MobilePhone1__c = '619139025';
        acc.Email_con__c = 'shop@acme.net';
        insert acc;

		// Need related with quote
		final Case needQ = FII_Util_GSM.createNeed(acc.Id, null, 'Need of Quote', null);
		FII_TRG_Case_Handler.bypassTrigger = true;
		insert needQ;
		FII_TRG_Case_Handler.bypassTrigger = false;

		// NE_Quote related to needQ
        NE__Quote__c quoteTest = new NE__Quote__c();
        quoteTest.FI_NEQ_SEL_Movement_Type__c = 'A';
        quoteTest.FI_NEQ_SEL_Flow_Controlling_Action__c = 'A';
		quoteTest.NE__AccountId__c = acc.Id;
		quoteTest.Case__c = needQ.Id;
		insert  quoteTest;
        
        NE__Order__c neOrder = new NE__Order__c();
        neOrder.NE__Quote__c = quoteTest.Id;
        insert neOrder;
        
        NE__OrderItem__c ordIt = new NE__OrderItem__c();
        ordIt.NE__Account__c = acc.Id;
        ordIt.NE__OrderId__c = neOrder.Id;
        ordIt.NE__Qty__c = 5;
        
        insert ordIt;

		// Need related with client and contact
		Case need = FII_Util_GSM.createNeed(con.AccountId, null, NEED_SUBJECT, null);
		FII_TRG_Case_Handler.bypassTrigger = true;
		insert need;
		FII_TRG_Case_Handler.bypassTrigger = false;

		// Interaction related with client and contact
		Task interaction1 = FII_Util_GSM.createInteraction(con.AccountId, con.Id, null, 'Phone', 'interaction1');
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert interaction1;
		FII_TRG_Task_Handler.bypassTrigger = false;
		need.FII_CAS_TXT_Opened_interaction__c = interaction1.Id;
		need.ContactId = con.Id;
		need.Origin = 'Phone';
		FII_TRG_Case_Handler.bypassTrigger = true;
		update need;
		FII_TRG_Case_Handler.bypassTrigger = false;

		// Action Case related with need
		Case actionCase = need.clone();
		actionCase.ParentId = need.Id;
		actionCase.RecordTypeId = IDRT_CAS_ACTION;
		actionCase.Subject = ACTION_CASE_SUBJECT;
		FII_TRG_Case_Handler.bypassTrigger = true;
		insert actionCase;
		FII_TRG_Case_Handler.bypassTrigger = false;

		// FASE 3
		F3A_Rejection__c rejection = new F3A_Rejection__c();
		rejection.F3A_REC_LKP_Account__c = acc.id;
		F3A_TRG_Rejection_Handler.bypassTrigger = true;
		insert rejection;
		F3A_TRG_Rejection_Handler.bypassTrigger = false;

		Task interactionRejection = new Task();
		interactionRejection.RecordTypeId = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_ACTION).Id;
		interactionRejection.Type = Label.FII_TaskType_Action;
		interactionRejection.Subject = 'F3A_Rejection__c ' + rejection.Name;
		interactionRejection.Status = 'Completed';
		interactionRejection.WhatId = rejection.Id;
		interactionRejection.FII_ACT_LKP_RelatedClient__c = rejection.F3A_REC_LKP_Account__c;
		interactionRejection.Description = rejection.F3A_REC_TXT_Explanation__c;
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert interactionRejection;
		FII_TRG_Task_Handler.bypassTrigger = false;

		
		// Interactions in progress
		final Map<Id,List<Task>> interactionsInProgressMap = FII_Util_GSM.getInteractionsInProgressBulk(new List<Id>{con.AccountId}, true);
		// Child Interaction of Action case related with need
		final Task interactionOfActionCase = FII_Util_GSM.createNewChildInteractions(new List<CAse>{actionCase}, interactionsInProgressMap)[0];
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert interactionOfActionCase;
		FII_TRG_Task_Handler.bypassTrigger = false;

		// Action Task related with need
		Task actionTask = FII_Util_GSM.createTaskAction(need, 'Modificación de datos', 'Completed', Label.FII_RT_TSK_ACTION);
		actionTask.WhoId = con.Id;
		actionTask.FII_ACT_SEL_Channel__c = 'Phone';
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert actionTask;
		FII_TRG_Task_Handler.bypassTrigger = false;
		
		// Child Interaction of Action Task related with need
		final Task interactionOfActionTask = FII_Util_GSM.createNewChildInteractions(new List<Task>{actionTask}, interactionsInProgressMap)[0];
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert interactionOfActionTask;
		FII_TRG_Task_Handler.bypassTrigger = false;

		// Interaction related with lead
		final Task interaction2 = FII_Util_GSM.createInteraction(null, null, newLead.Id, 'Phone', 'interaction2');
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert interaction2;
		FII_TRG_Task_Handler.bypassTrigger = false;
		// Interactions in progress
		final Map<Id,List<Task>> interactionsInProgressMapLead = FII_Util_GSM.getInteractionsInProgressBulk(new List<Id>{newLead.Id}, true);
		// Need related with leed
		Case need2 = FII_Util_GSM.createNeed(null, newLead.Id, NEED_LEAD_SUBJECT, null);
		FII_TRG_Case_Handler.bypassTrigger = true;
		insert need2;
		FII_TRG_Case_Handler.bypassTrigger = false;
		need2.FII_CAS_TXT_Opened_interaction__c = interaction2.Id;
		need2.Origin = 'Phone';
		FII_TRG_Case_Handler.bypassTrigger = true;
		update need2;
		FII_TRG_Case_Handler.bypassTrigger = false;

		// Action Case related with need2
		Case actionCase2 = need2.clone();
		actionCase2.ParentId = need2.Id;
		actionCase2.RecordTypeId = IDRT_CAS_ACTION;
		actionCase2.Subject = ACTION_CASE_SUBJECT+' LEAD';
		FII_TRG_Case_Handler.bypassTrigger = true;
		insert actionCase2;
		FII_TRG_Case_Handler.bypassTrigger = false;
		// Child Interaction of Action case related with need2
		final Task interactionOfActionCase2 = FII_Util_GSM.createNewChildInteractions(new List<Case>{actionCase2}, interactionsInProgressMapLead)[0];
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert interactionOfActionCase2;
		FII_TRG_Task_Handler.bypassTrigger = false;

		// Action Task related with need2
		Task actionTask2 = FII_Util_GSM.createTaskAction(need2, 'Modificación de datos', 'Completed', Label.FII_RT_TSK_ACTION);
		actionTask2.FII_ACT_SEL_Channel__c = 'Phone';
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert actionTask2;
		FII_TRG_Task_Handler.bypassTrigger = false;
		// Child Interaction of Action Task related with need2
		Task interactionOfActionTask2 = FII_Util_GSM.createNewChildInteractions(new List<Task>{actionTask2}, interactionsInProgressMapLead)[0];
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert interactionOfActionTask2;
		FII_TRG_Task_Handler.bypassTrigger = false;

		Test.stopTest();
	}

	@isTest private static void getInteractionsInProgressBulkTest(){
        final NE__OrderItem__c ordIt = [select Id from NE__OrderItem__c limit 1 ];
        final NE__Quote__c quote = [select Id from NE__Quote__c limit 1];
        List<Id> ids = new List<Id>();
        ids.add(ordIt.Id);
        ids.add(quote.Id);
		Map<Id,List<Task>> interactionList = FII_Util_GSM.getInteractionsInProgressBulk(ids, false);
		System.assertNotEquals(0, interactionList.values().size());
    }

	@isTest private static void consultRelatedNeeds() {
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		Test.startTest();
		final Task interaction = FII_Util_GSM.consultRelatedInteractions(acc.Id)[0];
		List<Case> needsList = new List<Case>();
		needsList = FII_Util_GSM.consultRelatedNeeds(con.Id);
		System.assertEquals(1, needsList.size());
		needsList = FII_Util_GSM.consultRelatedNeeds(acc.Id);
		System.assertEquals(1, needsList.size());
		needsList = FII_Util_GSM.consultRelatedNeeds(newLead.Id);
		System.assertEquals(1, needsList.size());
		needsList = FII_Util_GSM.consultRelatedNeeds(interaction.Id);
		System.assertEquals(1, needsList.size());
		Test.stopTest();
	}

	@isTest private static void consultRelatedActions() {
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		F3A_Rejection__c rejection = [SELECT Id FROM F3A_Rejection__c LIMIT 1];
		Test.startTest();
		final Task interaction = FII_Util_GSM.consultRelatedInteractions(acc.Id)[0];
		final Case need = [SELECT Id FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		List<SObject> actionsList = new List<Case>();
		actionsList = FII_Util_GSM.consultRelatedActions(con.Id);
		System.assertEquals(2, actionsList.size());
		actionsList = FII_Util_GSM.consultRelatedActions(acc.Id);
		System.assertEquals(2, actionsList.size());
		actionsList = FII_Util_GSM.consultRelatedActions(newLead.Id);
		System.assertEquals(2, actionsList.size());
		actionsList = FII_Util_GSM.consultRelatedActions(interaction.Id);
		System.assertEquals(2, actionsList.size());
		actionsList = FII_Util_GSM.consultRelatedActions(need.Id);
		System.assertEquals(2, actionsList.size());
		actionsList = FII_Util_GSM.consultRelatedActions(rejection.Id);
		Test.stopTest();
	}

	 @isTest private static void consultRelatedInteractions() {
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		Test.startTest();
		final Case need = [SELECT Id FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		List<Task> interactionsList = new List<Task>();
		interactionsList = FII_Util_GSM.consultRelatedInteractions(con.Id);
		System.assertEquals(1, interactionsList.size());
		interactionsList = FII_Util_GSM.consultRelatedInteractions(acc.Id);
		System.assertEquals(1, interactionsList.size());
		interactionsList = FII_Util_GSM.consultRelatedInteractions(newLead.Id);
		System.assertEquals(1, interactionsList.size());
		interactionsList = FII_Util_GSM.consultRelatedInteractions(need.Id);
		System.assertEquals(1, interactionsList.size());
		Test.stopTest();
	}

	@isTest private static void consultRecordPrimary() {
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		Test.startTest();
		final Task interaction = FII_Util_GSM.consultRelatedInteractions(acc.Id)[0];
		final Case need = [SELECT Id FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		SObject obj;
		obj = FII_Util_GSM.consultRecordPrimary(con.Id);
		System.assertNotEquals(null, obj);
		obj = FII_Util_GSM.consultRecordPrimary(acc.Id);
		System.assertNotEquals(null, obj);
		obj = FII_Util_GSM.consultRecordPrimary(newLead.Id);
		System.assertNotEquals(null, obj);
		obj = FII_Util_GSM.consultRecordPrimary(interaction.Id);
		System.assertNotEquals(null, obj);
		obj = FII_Util_GSM.consultRecordPrimary(need.Id);
		System.assertNotEquals(null, obj);
		Test.stopTest();
	}
	
	 @isTest private static void createInteractionAndCase() {
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		Test.startTest();
		List<Task> interactionList = new List<Task>();
		interactionList.add(FII_Util_GSM.createInteraction(acc.Id, con.Id, null, 'Chat', 'Interaction of Client'));
		interactionList.add(FII_Util_GSM.createInteraction(null, null, newLead.Id, 'Chat', 'Interaction of Lead'));
		insert interactionList;

		List<Case> needsList = new List<Case>();
		needsList.add(FII_Util_GSM.createNeed(con.AccountId, null,'New need related to Client', null));
		needsList.add(FII_Util_GSM.createNeed(null, newLead.Id,'New need related to Lead', null));
		insert needsList;

		List<Case> actionsCaseList = new List<Case>();
		final Case actionCase = FII_Util_GSM.createCaseAction(needsList[0].Id, con.AccountId, null, null, null, 'New Action Case related to Client', 'New', Label.FII_RT_CAS_ACTION);
		actionsCaseList.add(actionCase);
		final Case actionCase2 = FII_Util_GSM.createCaseAction(needsList[1].Id, null, newLead.Id, null, null, 'New Action Case related to Lead', 'New', Label.FII_RT_CAS_ACTION);
		actionsCaseList.add(actionCase2);
		insert(actionsCaseList);

		List<Task> actionsTaskList = new List<Task>();
		final Task actionTask = FII_Util_GSM.createTaskAction(needsList[0], 'Modificación de datos', 'Completed', Label.FII_RT_TSK_ACTION);
		actionsTaskList.add(actionTask);
		final Task actionTask2 = FII_Util_GSM.createTaskAction(needsList[1], 'Modificación de datos', 'Completed', Label.FII_RT_TSK_ACTION);
		actionsTaskList.add(actionTask2);
		insert(actionsTaskList);

		final Task interactionClient = [SELECT id, WhatId FROM Task WHERE Subject = 'Interacción: Interaction of Client' LIMIT 1];
		final Case needClient = [SELECT id FROM Case WHERE Subject = 'New need related to Client' LIMIT 1];
		System.assertEquals(needClient.Id, interactionClient.WhatId);

		final Task interactionLead = [SELECT id, FII_ACT_LKP_WhatId__c FROM Task WHERE Subject = 'Interacción: Interaction of Lead' LIMIT 1];
		final Case needLead = [SELECT id FROM Case WHERE Subject = 'New need related to Lead' LIMIT 1];
		System.assertEquals(needLead.Id, interactionLead.FII_ACT_LKP_WhatId__c);

		Test.stopTest();
	}

	@isTest private static void checkStatusOfNeed1() {
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		Case need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c, Origin, Lead__c, ContactId, AccountId FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		Case actionCase = [SELECT Id, Status FROM Case WHERE Subject = :ACTION_CASE_SUBJECT LIMIT 1];
		Test.startTest();
		System.assertEquals('New', need.Status);
		System.assertEquals(null, need.FII_CAS_DAT_Resolution_Date__c);
		actionCase.Status = 'Pending';
		update(actionCase);
		need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c, Origin, Lead__c, ContactId, AccountId FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		//System.assertEquals('New', need.Status);
		System.assertEquals(null, need.FII_CAS_DAT_Resolution_Date__c);

		actionCase.Status = 'Finalizado';
		update(actionCase);
		need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c, Origin, Lead__c, ContactId, AccountId, FII_CAS_LKP_Campaign__c FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		System.assertEquals('Resolved', need.Status);
		System.assertNotEquals(null, need.FII_CAS_DAT_Resolution_Date__c);

		Case actionCase2 = need.clone();
		actionCase2.ParentId = need.Id;
		actionCase2.RecordTypeId = IDRT_CAS_ACTION;
		actionCase2.Status = 'New';
		actionCase2.Subject = 'New Action Case related to Client';
		insert actionCase2;
		need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c, FII_CAS_LKP_Campaign__c, Lead__c, AccountId FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		System.assertEquals('New', need.Status);
		System.assertEquals(null, need.FII_CAS_DAT_Resolution_Date__c);
		Test.stopTest();
	}

	@isTest private static void checkStatusOfNeed2() {
		Test.startTest();
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		Case need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c, Origin, Lead__c, ContactId, AccountId, FII_CAS_LKP_Campaign__c FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		Case actionCase = [SELECT Id, Status FROM Case WHERE Subject = :ACTION_CASE_SUBJECT LIMIT 1];
		
		Task actionTask = FII_Util_GSM.createTaskAction(need, 'Modificación de datos of Client', 'Open', Label.FII_RT_TSK_ACTION);
		insert actionTask;
		need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		System.assertEquals('New', need.Status);
		System.assertEquals(null, need.FII_CAS_DAT_Resolution_Date__c);

		actionCase.Status = 'Finalizado';
		update actionCase;
		need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		System.assertEquals('New', need.Status);
		System.assertEquals(null, need.FII_CAS_DAT_Resolution_Date__c);

		actionTask.Status = 'Completed';
		update actionTask;
		need = [SELECT Id, Status, FII_CAS_DAT_Resolution_Date__c FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		System.assertEquals('Resolved', need.Status);
		//System.assertEquals(null, need.FII_CAS_DAT_Resolution_Date__c);
		Test.stopTest();
	}
	
	@isTest private static void mapApiNamePicklist() {
		final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		Test.startTest();
		List<Task> interactionsList = new List<Task>();
		interactionsList = FII_Util_GSM.consultRelatedInteractions(con.Id);
		interactionsList = (List<Task>)FII_Util_GSM.mapApiNamePicklist(interactionsList);
		System.assertNotEquals(null, interactionsList.size());

		List<Case> needsList = new List<Case>();
		needsList = FII_Util_GSM.consultRelatedNeeds(con.Id);
		needsList = (List<Case>)FII_Util_GSM.mapApiNamePicklist(needsList);
		System.assertNotEquals(null, needsList.size());
		Test.stopTest();
	}

	@isTest private static void standardBehaviorGSM0() {
        Test.setMock(HttpCalloutMock.class, new UtilHttpMock.BasicMock());

        Test.startTest();
        final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Case newNeed = (Case)FII_Util_GSM.standardBehaviorGSM(acc.Id, null, null, 'Test2', 'TestAct2', null, 'Completed', Label.FII_RT_CAS_ACTION)[0];
		Case newNeed2 = (Case)FII_Util_GSM.standardBehaviorGSM(newNeed.Id, null, null, 'Test3', 'TestAct3', null, 'Completed', Label.FII_RT_TSK_PAYMENT_AGREEMENT)[0];
		System.assertNotEquals(null, newNeed2);
		final Case newNeed3 = (Case)FII_Util_GSM.standardBehaviorGSM(con.Id, null, null, 'Test4', 'TestAct4', null, 'Completed', Label.FII_RT_TSK_PROVIDE_CONSUMPTIONS)[0];
		System.assertNotEquals(null, newNeed3);
        Test.stopTest();
	}

		@isTest private static void standardBehaviorGSM1() {
        Test.setMock(HttpCalloutMock.class, new UtilHttpMock.BasicMock());

        Test.startTest();
        final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Case newNeed = (Case)FII_Util_GSM.standardBehaviorGSM(acc.Id, null, null, 'Test', 'TestAct', null, 'Completed', Label.FII_RT_TSK_ACTION)[0];
		System.assertNotEquals(null, newNeed);
		Task task = FII_Util_GSM.getInteractionInProgress(newNeed.id);
		task.Status = 'Completed';
		update task;
		System.assertEquals(null, FII_Util_GSM.getInteractionInProgress(newNeed.id));
		final Task interactionAux = FII_Util_GSM.createInteraction(con.AccountId, con.Id, null, 'Phone', 'interactionAux');
		insert interactionAux;
		FII_Util_GSM.standardBehaviorGSM(newNeed.Id, null, null, 'Test5', 'TestAct5', null, 'Completed', Label.FII_RT_TSK_OBLIGATION_REMITTANCE);
		final Task action = [SELECT Id FROM Task WHERE Subject = 'TestAct5' LIMIT 1];
		final Task intAux = [SELECT Id, FII_ACT_TXT_Recruitment_interaction__c FROM Task WHERE Subject = 'Interacción: interactionAux' LIMIT 1];
		System.assertEquals(action.Id, intAux.FII_ACT_TXT_Recruitment_interaction__c);
        Test.stopTest();
	}
    
    @isTest private static void standardBehaviorGSM2() {
		Test.startTest();
        final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		        
		final Case newNeed4 = (Case)FII_Util_GSM.standardBehaviorGSM(newLead.Id, null, null, 'Test5', 'TestAct5', null, 'Completed', Label.FII_RT_TSK_URL_PAID)[0];
		System.assertNotEquals(null, newNeed4);
		final Case newNeed5 = (Case)FII_Util_GSM.standardBehaviorGSM(newNeed4.Id, null, null, 'Test6', 'TestAct6', null, 'Completed', Label.FII_RT_TSK_OBLIGATION_REMITTANCE)[0];
		System.assertNotEquals(null, newNeed5);
        Task task = FII_Util_GSM.getInteractionInProgress(newNeed5.id);
        System.assertNotEquals(null, task);
        Boolean disabled = FII_Util_GSM.disableButton(newLead.id,newLead.id,task);
        System.assertEquals(false, disabled);
		disabled = FII_Util_GSM.disableButton(newLead.id,newLead.id,null);
        System.assertEquals(false, disabled); // backoffice
		task.WhoId = null;
		task.FII_ACT_SEL_Channel__c = 'Chat';
		update task;
		disabled = FII_Util_GSM.disableButton(newLead.id,newLead.id,task);
        System.assertEquals(true, disabled);
		task.Status = 'Completed';
		update task;
		System.assertEquals(null, FII_Util_GSM.getInteractionInProgress(newNeed5.id));
		final Task interactionAux = FII_Util_GSM.createInteraction(null, null, newLead.Id, 'Phone', 'interactionAux');
		insert interactionAux;
		System.assertNotEquals(null, FII_Util_GSM.getInteractionInProgress(newNeed5.id));
        Test.stopTest();
	}
    
	@isTest private static void standardBehaviorGSM3() {                
        Test.setMock(HttpCalloutMock.Class , new UtilHttpMock.BasicMock());
        Test.startTest();
		final Account acc = [SELECT Id, Name FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Task int1 = [SELECT Id, FII_ACT_SEL_Channel__c FROM Task WHERE Subject = 'Interacción: interaction1' LIMIT 1];
		B2C_Address__c address = new B2C_Address__c();
        address.Premise_flg__c = true;
        address.Main_Address__c = false;
        address.Adress_active_flg__c = true;
        address.Country_cd__c = 'ES';
        address.Country_desc__c = 'ESPAÑA';
        address.Province_cd__c = '15';
        address.Province_text__c = 'A CORUÑA';
        address.County_cd__c = '030';
        address.County__c = 'A CORUÑA';
        address.City_cd__c = 'BER13108';
        address.City__c = 'A CORUÑA';
        address.INE_city_cd__c = '15030000101';
        address.Street_cd__c = 'BER0569533';
        address.Street__c = 'NELLE';
        address.INE_street_cd__c = '1503000423';
        address.Type_street__c = 'RD';
        address.Zipcode__c = '12345';
        address.Longitude__c = 0;
        address.Latitude__c = 0;
        address.Census_tract__c = '123';
        address.Street_number__c = '109';
        address.Point_duplicator_cd__c = 'A';
        address.Type_Point_lightener_cd__c = 'AFS';
        address.Point_lightener__c = 'S';
        address.Floor_cd__c = '4';
        address.Door__c = '2';
        address.Build__c = '1';
        address.Stairs__c  = '3';
        address.Adress_lightener__c = 'asdf';
        address.Type_address_cd__c = 'Normalized';
        address.Reference_year__c = 2010;
        address.INE_county_cd__c = '030';
        address.INE_city_cd__c = '15030000101';
        address.UTM_x__c = '2';
        address.UTM_y__c = '2';
        address.Trust_level__c = 5;
        address.CUPS_13_gas__c = 'CRM0001391063';
        address.CUPS_13_elec__c = 'CRM0001312697';
        address.Description_adress__c = 'Descripcion calle';
        address.INE_state_cd__c = 'PR';
        address.DIR_external_CRM_id__c = '123456789012345';
        address.Formatedd_Address__c = 'Formatedd Address';
        address.DIR_external_account_id__c = '123456789012345';
        address.DIR_external_contact_id__c = '123456789012345';
        address.Account__c=acc.Id;
		AddressTriggerHandler.bypassTrigger = true;
        insert address;
		AddressTriggerHandler.bypassTrigger = false;
        acc.Addr_id__c=address.id;
		AccountTriggerHandler.bypassTrigger = true;
        update acc;
		AccountTriggerHandler.bypassTrigger = false;
		
		final Case newNeed = (Case)FII_Util_GSM.standardBehaviorGSM(address.Id, null, null, 'Test', 'TestAct', null, 'Completed', Label.FII_RT_TSK_ACTION)[0];
		System.assertEquals(acc.Id, newNeed.AccountId);

		final Task task = FII_Util_GSM.getInteractionInProgress(address.id);
		System.assertEquals(int1.Id, task.Id);
        Test.stopTest();
	}

	    @isTest private static void standardBehaviorGSM4() {
		// Comprueba que si cerramos la interacción en curso, abrimos otra y realizamos una actuación sobre una necesidad abierta,
		// la interacción se relaciona con la actuación.
		Test.startTest();
        final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		final Case needLead = [SELECT Id FROM Case WHERE Subject = :NEED_LEAD_SUBJECT LIMIT 1];
		Task int2 = [SELECT Id, WhoId FROM Task WHERE Subject = 'Interacción: interaction2' LIMIT 1];
		int2.Status = 'Completed';
        FII_TRG_Task_Handler.bypassTrigger = true;
        update int2;
		final Task interactionAux = FII_Util_GSM.createInteraction(null, null, newLead.Id, 'Phone', 'interactionAux');
		insert interactionAux;
        FII_TRG_Task_Handler.bypassTrigger = false;
		FII_Util_GSM.standardBehaviorGSM(needLead.Id, null, null, 'Test5', 'TestAct5', null, 'Completed', Label.FII_RT_TSK_ACTION);
		final Task action = [SELECT Id FROM Task WHERE Subject = 'TestAct5' LIMIT 1];
		final Task intAux = [SELECT Id, FII_ACT_TXT_Recruitment_interaction__c FROM Task WHERE Subject = 'Interacción: interactionAux' LIMIT 1];
		System.assertEquals(action.Id, intAux.FII_ACT_TXT_Recruitment_interaction__c);
        Test.stopTest();
	}

    @isTest private static void setContact(){
        Test.startTest();
        Task int1 = [SELECT Id, WhoId FROM Task WHERE Subject = 'Interacción: interaction1' LIMIT 1];
        int1.WhoId = null;
		int1.FII_ACT_SEL_Channel__c = 'Chat';
        update int1;
        
        final Contact con = [SELECT Id, Name, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
        
        FII_Util_GSM.setContact(int1.Id,con.Id);
        
        int1 = [SELECT Id, WhoId FROM Task WHERE Subject = 'Interacción: interaction1' LIMIT 1];
        System.assertNotEquals(null,int1.WhoId);
        Test.stopTest();
    }

	@isTest private static void isTheEventForMe(){
		Test.startTest();
        final Task int1 = [SELECT Id, FII_ACT_LKP_RelatedClient__c, WhoId FROM Task WHERE Subject = 'Interacción: interaction1' LIMIT 1];
		final Task int2 = [SELECT Id, FII_ACT_SEL_Channel__c, WhoId FROM Task WHERE Subject = 'Interacción: interaction2' LIMIT 1];
		final Contact con = [SELECT Id FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		final Case need = [SELECT Id FROM Case WHERE Subject = :NEED_SUBJECT LIMIT 1];
		final Case needLead = [SELECT Id FROM Case WHERE Subject = :NEED_LEAD_SUBJECT LIMIT 1];
		final Lead newLead = [SELECT Id, Name FROM Lead WHERE Email = :LEAD_EMAIL LIMIT 1];
		Boolean isFormMe = false;

		// True asserts
		// El evento lo recibe el cliente y se envía desde el cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(acc.Id, acc.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el contacto y se envía desde el cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(con.Id, acc.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la necesidad del cliente y se envía desde el cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(need.Id, acc.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el cliente y se envía desde el contacto
		isFormMe = FII_Util_GSM.isTheEventForMe(acc.Id, con.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el contacto y se envía desde el contacto
		isFormMe = FII_Util_GSM.isTheEventForMe(con.Id, con.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la necesidad del cliente y se envía desde el contacto
		isFormMe = FII_Util_GSM.isTheEventForMe(need.Id, con.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el lead y se envía desde el lead
		isFormMe = FII_Util_GSM.isTheEventForMe(newLead.Id, newLead.Id, int2);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la necesidad del lead y se envía desde el lead
		isFormMe = FII_Util_GSM.isTheEventForMe(needLead.Id, newLead.Id, int2);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la necesidad del lead y se envía desde la necesidad del lead
		isFormMe = FII_Util_GSM.isTheEventForMe(needLead.Id, needLead.Id, int2);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el cliente y se envía desde la necesidad del cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(acc.Id, need.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el contacto y se envía desde la necesidad del cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(con.Id, need.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la necesidad del cliente y se envía desde la necesidad del cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(need.Id, need.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la interacción 1 y se envía desde el cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(int1.Id, acc.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la interacción 1 y se envía desde el contacto
		isFormMe = FII_Util_GSM.isTheEventForMe(int1.Id, con.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la interacción 1 y se envía desde la necesidad del cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(int1.Id, need.Id, int1);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe la interacción 1 y se envía desde la interacción 1
		isFormMe = FII_Util_GSM.isTheEventForMe(int1.Id, int1.Id, int1);
		System.assertEquals(true, isFormMe);

		// False asserts
		// El evento lo recibe el cliente y se envía desde el lead
		isFormMe = FII_Util_GSM.isTheEventForMe(acc.Id, newLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el contacto y se envía desde el lead
		isFormMe = FII_Util_GSM.isTheEventForMe(con.Id, newLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la necesidad del cliente y se envía desde el lead
		isFormMe = FII_Util_GSM.isTheEventForMe(need.Id, newLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el cliente y se envía desde la necesidad del lead
		isFormMe = FII_Util_GSM.isTheEventForMe(acc.Id, needLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el contacto y se envía desde la necesidad del lead
		isFormMe = FII_Util_GSM.isTheEventForMe(con.Id, needLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la necesidad del cliente y se envía desde la necesidad del lead
		isFormMe = FII_Util_GSM.isTheEventForMe(need.Id, needLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el lead y se envía desde el cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(newLead.Id, acc.Id, int1);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el lead y se envía desde el contacto
		isFormMe = FII_Util_GSM.isTheEventForMe(newLead.Id, con.Id, int1);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el lead y se envía desde la necesidad del cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(newLead.Id, need.Id, int1);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la necesidad del lead y se envía desde el cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(needLead.Id, acc.Id, int1);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la necesidad del lead y se envía desde el contacto
		isFormMe = FII_Util_GSM.isTheEventForMe(needLead.Id, con.Id, int1);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la necesidad del lead y se envía desde la necesidad del cliente
		isFormMe = FII_Util_GSM.isTheEventForMe(needLead.Id, need.Id, int1);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la interacción 1 y se envía desde el lead
		isFormMe = FII_Util_GSM.isTheEventForMe(int1.Id, newLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la interacción 1 y se envía desde la necesidad del lead
		isFormMe = FII_Util_GSM.isTheEventForMe(int1.Id, needLead.Id, int2);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe la interacción 1 y se envía desde la interacción 2
		isFormMe = FII_Util_GSM.isTheEventForMe(int1.Id, int2.Id, int2);
		System.assertEquals(false, isFormMe);

		Test.stopTest();
	}

	@isTest private static void isTheEventForMe2(){
		Test.startTest();
        final Task int1 = [SELECT Id, FII_ACT_LKP_RelatedClient__c, WhoId FROM Task WHERE Subject = 'Interacción: interaction1' LIMIT 1];
		final Contact con = [SELECT Id FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Account acc = [SELECT Id FROM Account WHERE NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		// Creamos un nuevo cliente
		final Account acc2 = new Account(Name = 'Autocalculado', Identifier_Type__c = 'NIF',
                                  NIF_CIF_Customer_NIE__c = '31841666Y', FirstName__c = 'Acc',
                                  LastName__c = 'Test', Physical_or_legal_cd__c = 'Physical Customer',
                                  Account_language__c = 'Español', Contact_method_cd__c = 'SMS',
                                  MobilePhone1__c = '632145987', No_Phone_flg__c  = false,
                                  No_Email_flg__c = true);
        AccountTriggerHandler.bypassTrigger = true;
		insert acc2;
		// Creamos un nuevo contacto
        final Contact con2 = new Contact(FirstName = 'Cont', LastName = 'Tests999',
                                   Contact_method_cd__c = 'SMS', AccountId = acc2.Id, MobilePhone = '632145987',
                                   No_Phone_flg__c  = false, No_Email_flg__c  = true, Document_Type__c = 'NIF',
                                   NIF_CIF_Customer_NIE__c = '73009311C');
		ContactTriggerHandler.bypassTrigger = true;
        insert con2;
		AccountTriggerHandler.bypassTrigger = false;
		ContactTriggerHandler.bypassTrigger = false;
		Boolean isFormMe = false;
		// Establecemos una relación de autorizado del anterior contacto con el cliente del testsetup
		AccountContactRelation acr = new AccountContactRelation(AccountId = acc.Id, ContactId = con2.Id, Roles = 'Autorizado');
        insert acr;
		// Creamos una interacción con el cliente del testsetup y el nuevo contacto autorizado
		final Task int3 = FII_Util_GSM.createInteraction(acc.Id, con2.Id, null, 'Phone', 'interaction3');
		FII_TRG_Task_Handler.bypassTrigger = true;
		insert int3;
		FII_TRG_Task_Handler.bypassTrigger = false;

		// El evento lo recibe el cliente 1 y se envía desde el contacto 2 (interacción 3)
		isFormMe = FII_Util_GSM.isTheEventForMe(acc.Id, con2.Id, int3);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el contacto 2 y se envía desde el cliente 1 (interacción 3)
		isFormMe = FII_Util_GSM.isTheEventForMe(con2.Id, acc.Id, int3);
		System.assertEquals(true, isFormMe);
		// El evento lo recibe el contacto 2 y se envía desde el cliente 1 (interacción 1)
		isFormMe = FII_Util_GSM.isTheEventForMe(con2.Id, acc.Id, int1);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el cliente 2 y se envía desde el cliente 1
		isFormMe = FII_Util_GSM.isTheEventForMe(acc2.Id, acc.Id, int3);
		System.assertEquals(false, isFormMe);
		// El evento lo recibe el cliente 2 y se envía desde el contacto 1 (interacción 1)
		isFormMe = FII_Util_GSM.isTheEventForMe(acc2.Id, con.Id, int1);
		System.assertEquals(false, isFormMe);

		Test.stopTest();
	}
	
	//END - IBBA's 411 - 858 - 861 - 366
	@isTest static void closedInteractionWithNeedOpen(){
        Test.setMock(HttpCalloutMock.class, new UtilHttpMock.BasicMock());
        Test.startTest();
		final Task int1 = [SELECT Id FROM Task WHERE Subject = 'Interacción: interaction1' LIMIT 1];
		Map<String, String> data = new Map<String, String>();
		data.put('interactionId', int1.Id);
		Flow.Interview.FII_FLW_Close_InteractionInCourse flow = new Flow.Interview.FII_FLW_Close_InteractionInCourse(data);
		FII_TRG_Task_Handler.bypassTrigger = true;
        flow.start();
        final Contact con = [SELECT Id, FII_CON_TXT_Hidden_URL_Survey1__c, FII_CON_TXT_Hidden_URL_Survey2__c FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
        System.assertEquals(null, con.FII_CON_TXT_Hidden_URL_Survey1__c);
		System.assertEquals(null, con.FII_CON_TXT_Hidden_URL_Survey2__c);
        FII_TRG_Task_Handler.bypassTrigger = false;
        Test.stopTest();
    }

    @isTest static void closedInteractionWithoutNeed(){
        Test.setMock(HttpCalloutMock.class, new UtilHttpMock.BasicMock());
        Test.startTest();
		final Contact con = [SELECT Id, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
        final Task interactionAux = FII_Util_GSM.createInteraction(con.AccountId, con.Id, null, 'Phone', 'interactionAux');
		insert interactionAux;
		Map<String, String> data = new Map<String, String>();
		data.put('interactionId', interactionAux.Id);
		Flow.Interview.FII_FLW_Close_InteractionInCourse flow = new Flow.Interview.FII_FLW_Close_InteractionInCourse(data);
		FII_TRG_Task_Handler.bypassTrigger = true;
        flow.start();
		final Contact conUpdated = [SELECT Id, FII_CON_TXT_Hidden_URL_Survey1__c, FII_CON_TXT_Hidden_URL_Survey2__c FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		System.assertEquals(null, conUpdated.FII_CON_TXT_Hidden_URL_Survey1__c);
		System.assertEquals(null, conUpdated.FII_CON_TXT_Hidden_URL_Survey2__c);
        FII_TRG_Task_Handler.bypassTrigger = false;
        Test.stopTest();
    }

    @isTest 
    private static void sendSurvey(){
		Test.setMock(HttpCalloutMock.class, new UtilHttpMock.BasicMock());
        Test.startTest();
        final Contact con = [SELECT Id, AccountId FROM Contact WHERE LastName = :CONTACT_LASTNAME LIMIT 1];
		final Task interactionAux = FII_Util_GSM.createInteraction(con.AccountId, con.Id, null, 'Phone', 'interactionAux');
		insert interactionAux; //Creamos interacción en curso
		
		Case need = FII_Util_GSM.createNeed(con.AccountId, null, 'Survey', null);
        need.FII_CAS_TXT_Opened_interaction__c = interactionAux.Id;
		need.Origin = 'Email'; 
        insert need; //Creamos need status new

		Map<String, String> data = new Map<String, String>();
		data.put('interactionId', interactionAux.Id);
		Flow.Interview.FII_FLW_Close_InteractionInCourse flow = new Flow.Interview.FII_FLW_Close_InteractionInCourse(data);
		flow.start(); //Cerramos interacción con el flow
	
		List<SObject> listatets = FII_Util_GSM.standardBehaviorGSM(con.AccountId,'Atencion al cliente','Consulta','Consulta lecturas','Consulta lecturas',null,'Completed',Label.FII_RT_TSK_ACTION);
		System.assert(!listatets.isEmpty(), 'lista vacia ');
        Test.stopTest();
    }
	//END - IBBA's 411 - 858 - 861 - 366

	@isTest  static void consultOpptyRelatedNeeds(){
        Case caseNeed = [SELECT Id, AccountId FROM Case WHERE Account.NIF_CIF_Customer_NIE__c = :ACCOUNT_NIF LIMIT 1];
		Opportunity o = new Opportunity();
		o.Name = 'Test';
		o.StageName = 'Pending Review';
		o.CloseDate = System.Today();
        o.FI_OPP_LKP_Case__c = caseNeed.Id;
        o.AccountId = caseNeed.AccountId;

		insert o;
        
        Test.startTest();
        Opportunity o2 = [Select StageName FROM Opportunity LIMIT 1];
        o2.StageName = 'Closed Won';
        update o2;
        
        List<sObject> aux = FII_Util_GSM.consultRelatedActions(o.Id);
        
        Map<Id, List<Task>> aux2 = FII_Util_GSM.getInteractionsInProgressBulk(new List<Id>{o.Id}, true);
        //System.assert(!aux.isEmpty(), 'lista sin datos');
         System.assert(aux2.isEmpty(), 'lista sin datos');
        Test.stopTest();
	}
}